/*
 * main_simple.c
 *
 *  Created on: 03.09.2009
 *      Author: daniel
 */

/*
 * 	Doku, siehe http://www.mikrocontroller.net/articles/AVR_FAT32
 *	Autor: Daniel R.
 */

#include <stdlib.h>
#include <avr/interrupt.h>
#include <avr/io.h>

#include "config.h"	// hier werden alle nötigen konfigurationen vorgenommen !
#include "file.h"
#include "fat.h"
#include "mmc.h"		// hardware abhängig
#include "uart.h"		// hardware abhängig


//*****************************************************************************************************************
void main(void){

	// Uart initialisierung zu Ausgabe von Daten
	uinit();

	uputs((unsigned char*)"\nBoot");

	//Versuch Karte zu Initialisieren, bis es klappt.
	while (FALSE==mmc_init()){
		nop();
	}

	uputs((unsigned char*)"...");


	// Fat initialisieren.
	if(TRUE == fat_loadFatData()){

	  uputs((unsigned char*)"Ok\n");		// wenn auf dem terminal "Boot... OK" zu lesen ist, ist Init OK. Jetzt kann man schreiben/lesen

	  // Dateinamen müssen in diesem Format sein !
	  unsigned char file_name[20]="TEST    TXT";

	  // string zum in die datei schreiben schreiben
	  unsigned char str[13]="Hallo Datei!";


	  // Datei existiert nicht, also anlegen !
	  if(MMC_FILE_NEW == ffopen(file_name)){

	     // schreibt String
	     ffwrites(str);

	     // neue Zeile in der Datei
	     ffwrite(0x0D);
	     ffwrite(0x0A);

	     // schließt Datei
	     ffclose();
	   }



	   // Datei existiert, also anhängen !
	   else{

	     ffseek(file.length);   // spult bis zum Dateiende vor um anzuhängen !

	     // schreibt String
	     ffwrites(str);

	     // neue Zeile in der Datei
	     ffwrite(0x0D);
	     ffwrite(0x0A);

	     // schließt Datei
	     ffclose();
	   }


	   // Datei existiert, also kann man lesen.
	   if(MMC_FILE_EXISTS == ffopen(file_name)){

	      // setzen einer Variable und dann runterzählen geht am schnellsten !
	      unsigned long int seek=file.length;

	      // lesen eines chars und Ausgabe des chars.
	      // solange bis komplette Datei gelesen wurde.
	      do{
	         uputc(ffread());
	      }while(--seek);

	      ffclose();
	   }

	  }

}
